
; ----------------------------------------------------------------------
;  Start point of 1st algo to test
; ----------------------------------------------------------------------

.data
even
	Algo2_Description	db	"Frank / SSE2"
				db	0

.code
align 16

Algo2_Run	proc	lpResult:DWORD

	; if you will add your tested code to shis file, the comment next 2 lines
	;mov eax,ALGO_IS_NOT_IMPLEMENTED
	;ret

	pushad

	; checking for supporting of this algo by CPU
	; specify which instructions is used by your code,
	; choose from the list:
	; 	ALGO_REQUIRE_i486
	; 	ALGO_REQUIRE_MMX
	;	ALGO_REQUIRE_SSE1
	;	ALGO_REQUIRE_SSE2
	;	ALGO_REQUIRE_SSE3
	;	ALGO_REQUIRE_SSSE3
	;	ALGO_REQUIRE_SSE41
	;	ALGO_REQUIRE_SSE42
	
	mov eax,2
	cmp dwMaxInstructionsSupported,ALGO_REQUIRE_SSE2	; select your instructions
	jb @algo2_exit


	
		
	; here can be placed anything - preparation of the algo
	; (allocation of memory etc) and calling to algo itself
	; or just placing of piece of code between timing macros

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	
		; labels for the code
		; you must place tested code (proc or just piece)
		; between that labels - just move them to needed place
		;algo2_start::
		
		call TestConvertXmm

		;algo2_end::
	
	counter_end
	
	; return the counter of the clocks to variable by reference
	mov ecx,lpResult
	mov [ecx],eax
	
	xor eax,eax
	
	@algo2_exit:
	
	; exit with restoration all of regs except EAX - return code
	mov dword ptr [esp+28],eax
	popad
	ret
	
Algo2_Run	endp


; uncomment these labels, and put code between them, if you
; used proc instead of piece of the code. Comment labels at proc above

algo2_start::
TestConvertXmm PROC

    lea  esi, FileBuffer
    lea  edi, MMXTestBuffer
    
    mov  ecx, NumCycles

    pxor xmm7,xmm7

    shr  ecx,1

    
    @@:
    
    movq      xmm0, qword ptr [esi]
    punpcklbw xmm0, xmm7
    add       esi,  Eight
    movdqa    [edi],xmm0
    add  edi, (Eight * Two)
    dec  ecx
    jnz  @B
    
    
    ret    

TestConvertXmm ENDP

algo2_end::


; ----------------------------------------------------------------------
;  End point of 1st algo to test
; ----------------------------------------------------------------------

